#convert xml to brat format
import glob
try:
	import xml.etree.cElementTree as ET
except ImportError:
	import xml.etree.ElementTree as ET

#folder of TAASSC-parsed files:
filenames = glob.glob("mod_parsed/*.xml")

punct_list = ". , ! & ( ) # ? : ; $ ' ''".split(" ")
pos_list = []
dep_list = []

for files in filenames:
	tree = ET.ElementTree(file=files) #The file is opened by the XML parser
	#create .txt and .ann files:
	outf = file("data/taassc_files/"+files.split("/")[-1][:-8]+".ann", "w")
	outf2= file("data/taassc_files/"+files.split("/")[-1][:-4], "w")
	
	ct = 0
	char_ct = 0
	rct = 0
	
	for sentences in tree.iter("sentence"):
		start_count = ct
		sent_list = []
		
		for tokens in sentences.iter("token"):
			ct+=1
			id = "T" + str(ct)
			word = tokens[0].text
			pos = tokens[4].text
			if pos in punct_list:
				pos = "punct"
			if "$" in pos:
				pos = pos.replace("$", "_POSS")
			pos_list.append(pos)
			if char_ct == 0:
				st_char = char_ct
			else:
				char_ct+=1
				st_char = char_ct
			char_ct += len(word)
			fin_char = char_ct
			
			sent_list.append(word)
			outf.write(id + "\t" + " ".join([pos, str(st_char),str(fin_char)]) + "\t" + word + "\n")
		outf2.write(" ".join(sent_list) + "\n")
		for deps in sentences.iter("dependencies"): #iterates through dependencies

			if deps.get('type') == "collapsed-ccprocessed-dependencies": #only iterate through cc-processed-dependencies
				
				for dependencies in deps.iter("dep"): # iterate through the dependencies
					if dependencies[0].text == "ROOT":
						continue
					if dependencies.get("type") == "punct":
						continue
					rct+=1
					rid = "R" + str(rct)
					relation = dependencies.get("type")
					dep_list.append(relation)
					arg1 = "Arg1:T"+ str(int(dependencies[0].get("idx"))+start_count)
					arg2 = "Arg2:T"+ str(int(dependencies[1].get("idx"))+start_count)
					outf.write(rid + "\t" + " ".join([relation,arg1,arg2]) +"\n")
	outf.flush()
	outf.close()
	outf2.flush()

#posf = file("pos_list.txt","w")
#depf = file("dep_list.txt", "w")

#for item in set(pos_list):
#	posf.write(item + "\n")

#for item in set(dep_list):
#	depf.write(item + "\n")
	